
eval('data_5_cap66uF_batteis');


x = d(1).d;  % table with columns V,f,C',C" from capacitor alone 
% x = x(1:end-1,:);  % unfortunate - to fit with lithium batt, which is missing final point
v = x(:,1);  % 
f = x(:,2);  % frequencies .. to check against the other cases 
Cc = (x(:,3)-1j*x(:,4));
Zc = 1 ./ ( 1j * 2*pi*f .* Cc );
i = v./Zc;

xa = d(3).d;  % alkaline battery in series (+ pole towards idax 'high')
%   xa = xa(1:end-1,:);  % unfortunate - to fit with lithium batt, which is missing final point
va = xa(:,1);
fa = xa(:,2);
assert( all( abs(fa./f - 1) < 1e-2 ) ); 
Cca = (xa(:,3)-1j*xa(:,4));
Zca = 1 ./ ( 1j * 2*pi*fa .* Cca );
ia = va./Zca;

xl = d(6).d;  % lithium battery in series (+ pole towards idax 'high')
vl = xl(:,1);
fl = xl(:,2);
assert( all( abs(fl./f(1:end-1) - 1) < 1e-2 ) ); 
Ccl = (xl(:,3)-1j*xl(:,4)); 
Zcl = 1 ./ ( 1j * 2*pi*fl .* Ccl );
il = vl./Zcl;


if 0  % consider a bit of plotting 
	i_m = abs(i); f_=f;  Cc_=Cc;   % choose which set to use (from the above) 
	plot3( i_m, f_,  real(Cc_), 'bo' ); 
	hold on
	plot3( i_m, f_, -imag(Cc_), 'rx' ); 
	hold off
	legend('$C''$', '$C''''$');
	set(gca,'ytick',10.^[-2:2])
	set(gca,'xscale','log','yscale','log','zscale','log')
	xlabel('$i$/A'); ylabel('$f$/Hz'); zlabel('{$C''$,$C"$} / F')
end

% the easy bit: results for the battery alone
Zeis_a = Zca - Zc;  
Zeis_l = Zcl - Zc(1:end-1);

% plain vs-frequency plots 
figure(1); 
loglog( fa, real(Zeis_a), 'b.-', ...
        fa, -imag(Zeis_a), 'r.-', ...
        fl, real(Zeis_l), 'c.-', ...
        fl, -imag(Zeis_l), 'm.-' );

% nyquist plot
figure(2);
plot( real(Zeis_a), -imag(Zeis_a), 'r.-', ...
      real(Zeis_l), -imag(Zeis_l), 'm.-' ); 
axis square equal;

% wow!  some strange results, with the lithium one going negative (i.e. +Z), 
% which appears to be not totally without precedent (see following in Elsevier), 
%   myth_reality_about_the_origin_of_inductive_loops_in_impedance_spectra_of_lithium_ion_electrodes_critical_experimental_approach__Brandstätter_2016.pdf  
%   negative_capacitance_of_inductive_loop__a_general_assessment_of_a_common_low_frequency_impedance_feature__Klotz_2019.pdf
% although it does seem pretty likely that this is due to measurement....?


% output for use with other data 
eis_pt2 = [ f, Zeis_a, [Zeis_l;NaN] ]




