%  plot to show how far the actual test current was from the intention
%  (intended value was ~1 mA, but accepting it wouldn't quite be reached 
%   in the extreme cases)
%  main deviation of current from intended is when battery impedance is 
%  significant compared to 66uF capacitor impedance, so higher f*V product 
%  would be needed


eval( 'data_5_cap66uF_batteis' );

figure(7);



% plain single 3D plot, all points, V,f,I
if 0
V=[];f=[];I=[]; for i=1:numel(d); x=d(i).d; I=[I;abs(x(:,3)-1j*x(:,4)).*2*pi*x(:,2).*x(:,1)], V=[V;x(:,1)], f=[f;x(:,2)], end
plot3( V, f, I, 'x' ); set(gca, 'yscale','log', 'xscale','log', 'zscale','log' );
xlabel('$v_\mathrm{pk}$ / V');  ylabel('$f$ / Hz');  zlabel('$i$ / A');
end


% plot with different colour for each measurement set

clrs='rmbcygk';
legs = {};
hold off;

%for i=[1,3,6]  % sweeps with constant f*V product 
for i=[1,2,3,4,5,6,7]  % all
    legs = [legs, {strrep(d(i).N,'_',' ')}];
    plot3( d(i).d(:,1), d(i).d(:,2), abs(d(i).d(:,3)-1j*d(i).d(:,4)).*(2*pi*d(i).d(:,2)).*d(i).d(:,1), ['x',clrs(i)] );
    hold on;
end
hold off;

legend(legs);
set(gca,'yscale','log'); 
set(gca,'xscale','log'); 
set(gca,'zscale','log');
xlabel('$v_\mathrm{pk}$ / V'); 
ylabel('$f$ / Hz'); 
zlabel('$i$ / A');
set(gca, 'xtick',10.^[-3:2], 'ytick',10.^[-2:2]);


%saveas(gcf,'fig_5x_v-f-i_3D_plot.fig');
